#define VLB_OK            0
#define VLB_ERR           -1
#define VLB_ENDOFFILE     -1

#define VLBS_USEDATAVALUES     0x8000L
#define VLBS_NOTIFY            0x0001L
#define VLBS_NOREDRAW          0x0004L
#define VLBS_OWNERDRAWFIXED    0x0010L
#define VLBS_HASSTRINGS        0x0040L
#define VLBS_USETABSTOPS       0x0080L
#define VLBS_NOINTEGRALHEIGHT  0x0100L
#define VLBS_WANTKEYBOARDINPUT 0x0400L
#define VLBS_DISABLENOSCROLL   0x1000L

// Application->VLIST messages
#define VLB_RESETCONTENT        (WM_USER+100)
#define VLB_SETCURSEL           (WM_USER+101)
#define VLB_GETCURSEL           (WM_USER+102)
#define VLB_GETTEXT             (WM_USER+103)
#define VLB_GETTEXTLEN          (WM_USER+104)
#define VLB_GETCOUNT            (WM_USER+105)
#define VLB_SELECTSTRING        (WM_USER+106)
#define VLB_FINDSTRING          (WM_USER+107)
#define VLB_GETITEMRECT         (WM_USER+108)
#define VLB_GETITEMDATA         (WM_USER+109)
#define VLB_SETITEMDATA         (WM_USER+110)
#define VLB_SETITEMHEIGHT       (WM_USER+111)
#define VLB_GETITEMHEIGHT       (WM_USER+112)
#define VLB_FINDSTRINGEXACT     (WM_USER+113)
#define VLB_INITIALIZE          (WM_USER+114)
#define VLB_FIRST               (WM_USER+115)
#define VLB_PREV                (WM_USER+116)
#define VLB_NEXT                (WM_USER+117)
#define VLB_LAST                (WM_USER+118)
#define VLB_FINDITEM            (WM_USER+119)
#define VLB_RANGE               (WM_USER+120)
#define VLB_FINDPOS             (WM_USER+121)
#define VLB_UPDATEPAGE          (WM_USER+123)
#define VLB_SETTABSTOPS         (WM_USER+124)
#define VLB_GETTOPINDEX         (WM_USER+125)
#define VLB_SETTOPINDEX         (WM_USER+126)
#define VLB_GETHORIZONTALEXTENT (WM_USER+127)
#define VLB_SETHORIZONTALEXTENT (WM_USER+128)
#define VLB_GETLINES            (WM_USER+129)
#define VLB_PAGEDOWN            (WM_USER+130)
#define VLB_PAGEUP              (WM_USER+131)

// VLIST->Application messages
#define VLBR_FINDSTRING         (WM_USER+605) 
#define VLBR_FINDSTRINGEXACT    (WM_USER+606) 
#define VLBR_SELECTSTRING       (WM_USER+607) 
#define VLBR_GETITEMDATA        (WM_USER+610)
#define VLBR_GETTEXT            (WM_USER+612)
#define VLBR_GETTEXTLEN         (WM_USER+613)

// VLIST->Application Notifications
#define VLBN_FREEITEM            (WM_USER+700)
#define VLBN_FREEALL             (WM_USER+701)

#define IDS_VLBOXNAME         1

typedef struct _VLBStruct {
   int   nCtlID;
   int   nStatus;
   LONG  lData;
   LONG  lIndex;
   LPSTR lpTextPointer;
   LPSTR lpFindString;
} VLBSTRUCT;

typedef VLBSTRUCT FAR*  LPVLBSTRUCT;

#define VLIST_CLASSNAME "VList"                    
extern BOOL WINAPI RegisterVListBox(HINSTANCE);
